<?xml version="1.0" encoding="UTF-8"?>
<!-- Use subject to the conditions in the included file: LICENSE.bsd -->
<!-- $Id$ -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
                xmlns:fo="http://www.w3.org/1999/XSL/Format"  
                version="1.0">
  
  <xsl:template match="corpauthor | 
                       copyright | 
                       year |
                       holder |
                       corpcredit |
                       corpname |
                       date |
                       edition |
                       editor |
                       firstname |
                       honorific |
                       indexterm |
                       invpartnumber |
                       isbn |
                       issn |
                       issuenum |
                       lineage |
                       orgname |
                       othercredit |
                       othername |
                       pagenums |
                       printhistory |
                       productname |
                       productnumber |
                       pubdate |
                       publisher |
                       publishername |
                       pubsnumber |
                       releaseinfo |
                       revhistory |
                       seriesinfo |
                       seriesvolnums |
                       subtitle |
                       surname |
                       title |
                       titleabbrev |
                       volumenum |
                       orgdiv |
                       collabname |
                       conftitle |
                       confnum |
                       confsponsor |
                       bibliocoverage |
                       biblioid |
                       bibliorelation |
                       bibliosource |
                       abbrev |
                       abstract |
                       address |
                       affiliation |
                       shortaffil |
                       jobtitle |
                       artheader |
                       articleinfo |
                       artpagenums |
                       author |
                       authorblurb |
                       personblurb |
                       authorgroup |
                       authorinitials |
                       bibliomisc |
                       bibliomset |
                       biblioset |
                       biblioset/title |
                       biblioset/citetitle |
                       bookbiblio |
                       citetitle |
                       collab |
                       confgroup |
                       contractnum |
                       contractsponsor |
                       contrib" mode="bibliography.mode">
    <xsl:variable name="class" select="generate-id()"/>
    <xsl:choose>
      <xsl:when test="ancestor-or-self::*[@revisionflag]">
        <fo:inline xsl:use-attribute-sets="ancestor.revision.atts">
          <!-- open a changebar here if the revisionflag is here and we have set them to be on -->
          <xsl:if test="$use.changebars != 0">
            <fo:change-bar-begin change-bar-class="{$class}" xsl:use-attribute-sets="changebar.atts"/>
          </xsl:if>
          <xsl:apply-imports/>
          <!-- close the changebar here if the revisionflag is here and we have set them to be on -->
          <xsl:if test="$use.changebars != 0 ">
            <fo:change-bar-end change-bar-class="{$class}"/>
          </xsl:if>
        </fo:inline>
      </xsl:when>
      <xsl:otherwise>
        <xsl:apply-imports/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  
  <xsl:template match="corpauthor | 
                       copyright | 
                       year |
                       holder |
                       corpcredit |
                       corpname |
                       date |
                       edition |
                       editor |
                       firstname |
                       honorific |
                       indexterm |
                       invpartnumber |
                       isbn |
                       issn |
                       issuenum |
                       lineage |
                       orgname |
                       othercredit |
                       othername |
                       pagenums |
                       printhistory |
                       productname |
                       productnumber |
                       pubdate |
                       publisher |
                       publishername |
                       pubsnumber |
                       releaseinfo |
                       revhistory |
                       seriesinfo |
                       seriesvolnums |
                       subtitle |
                       surname |
                       title |
                       titleabbrev |
                       volumenum |
                       orgdiv |
                       collabname |
                       conftitle |
                       confnum |
                       confsponsor |
                       bibliocoverage |
                       biblioid |
                       bibliorelation |
                       bibliosource |
                       abbrev |
                       abstract |
                       address |
                       affiliation |
                       shortaffil |
                       jobtitle |
                       artheader |
                       articleinfo |
                       artpagenums |
                       author |
                       authorblurb |
                       personblurb |
                       authorgroup |
                       authorinitials |
                       bibliomisc |
                       bibliomset |
                       biblioset |
                       biblioset/title |
                       biblioset/citetitle |
                       bookbiblio |
                       citetitle |
                       collab |
                       confgroup |
                       contractnum |
                       contractsponsor |
                       contrib" mode="bibliomixed.mode">
    <xsl:variable name="class" select="generate-id()"/>
    <xsl:choose>
      <xsl:when test="ancestor-or-self::*[@revisionflag]">
        <fo:inline xsl:use-attribute-sets="ancestor.revision.atts">
          <!-- open a changebar here if the revisionflag is here and we have set them to be on -->
          <xsl:if test="$use.changebars != 0">
            <fo:change-bar-begin change-bar-class="{$class}" xsl:use-attribute-sets="changebar.atts"/>
          </xsl:if>
          <xsl:apply-imports/>
          <!-- close the changebar here if the revisionflag is here and we have set them to be on -->
          <xsl:if test="$use.changebars != 0 ">
            <fo:change-bar-end change-bar-class="{$class}"/>
          </xsl:if>
        </fo:inline>
      </xsl:when>
      <xsl:otherwise>
        <xsl:apply-imports/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  
</xsl:stylesheet>