<?xml version="1.0" encoding="UTF-8"?>
<!-- Use subject to the conditions in the included file: LICENSE.bsd -->
<!-- $Id$ -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:fo="http://www.w3.org/1999/XSL/Format" 
                version="1.0">

  <xsl:template match="abstract |
                       abstract/title |
                       ackno | 
                       answer/*|
                       bibliodiv |
                       bibliomixed |
                       blockquote |
                       bridgehead |
                       callout |
                       calloutlist |
                       caption |
                       caution |
                       classsynopsis |
                       cmdsynopsis |
                       constructorsynopsis |
                       dedication |
                       deconstructorsynopsis |
                       epigraph |
                       equation |
                       example |
                       fieldsynopsis |
                       figure |
                       formalpara |
                       funcprototype |
                       funcsynopsis |
                       funcsynopsisinfo |
                       graphic |
                       graphicco |
                       highlights |
                       imageobjectco |
                       important |
                       informalequation |
                       informalexample |
                       informalfigure |
                       informaltable | 
                       itemizedlist | 
                       legalnotice |
                       literallayout |
                       mediaobject |
                       mediaobjectco |
                       member |
                       methodsynopsis |
                       msg |
                       msgentry |
                       msgexplan |
                       msgmain |
                       msgset |
                       note |
                       orderedlist |
                       para |
                       personblurb |
                       primaryie |
                       printhistory |
                       procedure |
                       programlisting |
                       programlistingco |
                       qandadiv |
                       qandaentry |
                       qandaset |
                       question |
                       refentry |
                       refentrytitle |
                       reference |
                       refnamediv |
                       refsect1 |
                       refsect2 |
                       refsect3 |
                       refsection |
                       refsynopsisdiv |
                       screen |
                       screenco |
                       screenshot |
                       secondaryie |
                       sect1 | 
                       sect2 | 
                       sect3 | 
                       sect4 | 
                       sect5 | 
                       section | 
                       seealsoie |
                       seeie |
                       seg |
                       segmentedlist |
                       sidebar |
                       simpara |
                       simplemsgentry |
                       simplelist |
                       simplesect |
                       step |
                       stepalternatives |
                       substeps |
                       synopfragment |
                       synopfragmentref |
                       synopsis |
                       table | 
                       task |
                       taskprerequisites |
                       taskrelated |
                       tasksummary |
                       tertiaryie |
                       tip |
                       variablelist |
                       warning">
    <xsl:variable name="class" select="generate-id()"/>
    <xsl:choose>
      <xsl:when test="ancestor-or-self::*[@revisionflag]">
        <fo:block xsl:use-attribute-sets="ancestor.revision.atts">
          <!-- open a changebar here if we have set them to be on -->
          <xsl:if test="$use.changebars != 0">
            <fo:change-bar-begin change-bar-class="{$class}" xsl:use-attribute-sets="changebar.atts"/>
          </xsl:if>
          <xsl:apply-imports/>
          <!-- close the changebar here if we have set them to be on -->
          <xsl:if test="$use.changebars != 0">
            <fo:change-bar-end change-bar-class="{$class}"/>
          </xsl:if>
        </fo:block>
      </xsl:when>
      <xsl:otherwise>
        <xsl:apply-imports/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

</xsl:stylesheet>