<?xml version="1.0" encoding="UTF-8"?>
<!-- Use subject to the conditions in the included file: LICENSE.bsd -->
<!-- $Id$ -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:fo="http://www.w3.org/1999/XSL/Format" 
                version="1.0">
                
  <xsl:template match="abbrev |
                       accel |
                       acronym |
                       action |
                       application |
                       arg |
                       attribution |
                       biblioref |
                       citation |
                       citetitle |
                       city |
                       classname |
                       co |
                       code |
                       command |
                       computeroutput |
                       confdates |
                       confnum |
                       confsponsor |
                       conftitle |
                       constant |
                       contractnum |
                       contractsponsor |
                       contrib |
                       copyright |
                       coref |
                       corpauthor |
                       corpcredit |
                       corpname |
                       country |
                       database |
                       date |
                       edition |
                       editor |
                       email |
                       emphasis |
                       entry/text() | 
                       envar |
                       errorcode |
                       errorname |
                       errortext |
                       errortype |
                       exceptionname |
                       fax |
                       filename |
                       firstname |
                       firstterm |
                       foreignphrase |
                       funcdef |
                       funcpara |
                       function |
                       group |
                       guibutton |
                       guiicon |
                       guilabel |
                       guimenu |
                       guimenuitem | 
                       guisubmenu |
                       hardware |
                       holder |
                       honorific |
                       initializer |
                       inlineequation |
                       inlinegraphic |
                       inlinemediaobject |
                       interface |
                       interfacename |
                       invpartnumber |
                       isbn |
                       issn |
                       issuenum |
                       jobtitle |
                       keycap |
                       keycode |
                       keycombo |
                       keysym |
                       label |
                       literal |
                       lineage | 
                       lineannotation |
                       link |
                       manvolnum |
                       markup |
                       mathphrase |
                       medialabel |
                       menuchoice |
                       methodname |
                       methodparam |
                       modifier |
                       mousebutton |
                       msgaud |
                       msglevel |
                       msgorig |
                       msgrel |
                       msgsub |
                       msgtext |
                       olink |
                       ooclass |
                       ooexception |
                       oointerface |
                       option |
                       optional |
                       orgdiv |
                       orgname |
                       otheraddr |
                       othercredit |
                       othername |
                       package |
                       pagenums |
                       paramdef |
                       parameter |
                       personname |
                       phone |
                       phrase |
                       pob |
                       postcode |
                       productname |
                       productnumber |
                       prompt |
                       property |
                       pubdate |
                       publishername |
                       pubsnumber |
                       quote |
                       refclass |
                       refdescriptor |
                       refmiscinfo |
                       refname |
                       refpurpose |
                       remark |
                       releaseinfo |
                       replaceable |
                       returnvalue |
                       seriesvolnums |
                       sgmltag |
                       shortaffil |
                       shortcut |
                       state |
                       street |
                       structfield |
                       structname |
                       subscript |
                       superscript |
                       surname |
                       symbol |
                       systemitem |
                       td/text() |
                       term |
                       termdef |
                       textdata |
                       th/text() |
                       token |
                       trademark |
                       type |
                       uri |
                       userinput |
                       varargs |
                       varname |
                       void |
                       volumenum |
                       wordasword |
                       xref">
    <xsl:variable name="class" select="generate-id()"/>
    <xsl:choose>
      <xsl:when test="ancestor-or-self::*[@revisionflag]">
        <fo:inline xsl:use-attribute-sets="ancestor.revision.atts">
          <!-- open a changebar here if the revisionflag is here and we have set them to be on -->
          <xsl:if test="$use.changebars != 0 ">
            <fo:change-bar-begin change-bar-class="{$class}" xsl:use-attribute-sets="changebar.atts"/>
          </xsl:if>
          <xsl:apply-imports/>
          <!-- close the changebar here if the revisionflag is here and we have set them to be on -->
          <xsl:if test="$use.changebars != 0 ">
            <fo:change-bar-end change-bar-class="{$class}"/>
          </xsl:if>
        </fo:inline>
      </xsl:when>
      <xsl:otherwise>
        <xsl:apply-imports/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  
  <xsl:template match="abbrev |
                       accel |
                       acronym |
                       action |
                       application |
                       arg |
                       attribution |
                       biblioref |
                       citation |
                       citetitle |
                       city |
                       classname |
                       co |
                       code |
                       command |
                       computeroutput |
                       confdates |
                       confnum |
                       confsponsor |
                       conftitle |
                       constant |
                       contractnum |
                       contractsponsor |
                       contrib |
                       copyright |
                       coref |
                       corpauthor |
                       corpcredit |
                       corpname |
                       country |
                       database |
                       date |
                       edition |
                       editor |
                       email |
                       emphasis |
                       entry/text() | 
                       envar |
                       errorcode |
                       errorname |
                       errortext |
                       errortype |
                       exceptionname |
                       fax |
                       filename |
                       firstname |
                       firstterm |
                       foreignphrase |
                       funcdef |
                       funcpara |
                       function |
                       graphic |
                       group |
                       guibutton |
                       guiicon |
                       guilabel |
                       guimenu |
                       guimenuitem | 
                       guisubmenu |
                       hardware |
                       holder |
                       honorific |
                       initializer |
                       inlineequation |
                       inlinegraphic |
                       inlinemediaobject |
                       interface |
                       interfacename |
                       invpartnumber |
                       isbn |
                       issn |
                       issuenum |
                       jobtitle |
                       keycap |
                       keycode |
                       keycombo |
                       keysym |
                       label |
                       literal |
                       lineage | 
                       lineannotation |
                       link |
                       manvolnum |
                       markup |
                       mathphrase |
                       medialabel |
                       menuchoice |
                       methodname |
                       methodparam |
                       modifier |
                       mousebutton |
                       msgaud |
                       msglevel |
                       msgorig |
                       msgrel |
                       msgsub |
                       msgtext |
                       olink |
                       ooclass |
                       ooexception |
                       oointerface |
                       option |
                       optional |
                       orgdiv |
                       orgname |
                       otheraddr |
                       othercredit |
                       othername |
                       package |
                       pagenums |
                       paramdef |
                       parameter |
                       personname |
                       phone |
                       phrase |
                       pob |
                       postcode |
                       productname |
                       productnumber |
                       prompt |
                       property |
                       pubdate |
                       publishername |
                       pubsnumber |
                       quote |
                       refclass |
                       refdescriptor |
                       refmiscinfo |
                       refname |
                       refpurpose |
                       remark |
                       releaseinfo |
                       replaceable |
                       returnvalue |
                       seriesvolnums |
                       sgmltag |
                       shortaffil |
                       shortcut |
                       state |
                       street |
                       structfield |
                       structname |
                       subscript |
                       superscript |
                       surname |
                       symbol |
                       systemitem |
                       td/text() |
                       term |
                       termdef |
                       textdata |
                       th/text() |
                       token |
                       trademark |
                       type |
                       uri |
                       userinput |
                       varargs |
                       varname |
                       void |
                       volumenum |
                       wordasword |
                       xref" mode='no.anchor.mode'>
    <xsl:variable name="class" select="generate-id()"/>
    <xsl:choose>
      <xsl:when test="ancestor-or-self::*[@revisionflag]">
        <fo:inline xsl:use-attribute-sets="ancestor.revision.atts">
          <!-- open a changebar here if the revisionflag is here and we have set them to be on -->
          <xsl:if test="$use.changebars != 0 ">
            <fo:change-bar-begin change-bar-class="{$class}" xsl:use-attribute-sets="changebar.atts"/>
          </xsl:if>
          <xsl:apply-imports/>
          <!-- close the changebar here if the revisionflag is here and we have set them to be on -->
          <xsl:if test="$use.changebars != 0 ">
            <fo:change-bar-end change-bar-class="{$class}"/>
          </xsl:if>
        </fo:inline>
      </xsl:when>
      <xsl:otherwise>
        <xsl:apply-imports/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  
  <xsl:template match="segtitle" mode="segtitle-in-seg">
    <xsl:variable name="class" select="generate-id()"/>
    <xsl:choose>
      <xsl:when test="ancestor-or-self::*[@revisionflag]">
        <fo:inline xsl:use-attribute-sets="ancestor.revision.atts">
          <!-- open a changebar here if the revisionflag is here and we have set them to be on -->
          <xsl:if test="$use.changebars != 0 ">
            <fo:change-bar-begin change-bar-class="{$class}" xsl:use-attribute-sets="changebar.atts"/>
          </xsl:if>
          <xsl:apply-imports/>
          <!-- close the changebar here if the revisionflag is here and we have set them to be on -->
          <xsl:if test="$use.changebars != 0 ">
            <fo:change-bar-end change-bar-class="{$class}"/>
          </xsl:if>
        </fo:inline>
      </xsl:when>
      <xsl:otherwise>
        <xsl:apply-imports/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  
  <xsl:template match="*" mode="object.title.markup">
    <xsl:variable name="class" select="generate-id()"/>
    <xsl:choose>
      <xsl:when test="child::title[@revisionflag='added']">
        <fo:inline xsl:use-attribute-sets="added.atts">
          <!-- open a changebar here if the revisionflag is here and we have set them to be on -->
          <xsl:if test="$use.changebars != 0 ">
            <fo:change-bar-begin change-bar-class="{$class}" xsl:use-attribute-sets="changebar.atts"/>
          </xsl:if>
          <xsl:apply-imports/>
          <!-- close the changebar here if the revisionflag is here and we have set them to be on -->
          <xsl:if test="$use.changebars != 0 ">
            <fo:change-bar-end change-bar-class="{$class}"/>
          </xsl:if>
        </fo:inline>
      </xsl:when>
      <xsl:when test="child::title[@revisionflag='deleted']">
        <fo:inline xsl:use-attribute-sets="deleted.atts">
          <!-- open a changebar here if the revisionflag is here and we have set them to be on -->
          <xsl:if test="$use.changebars != 0 ">
            <fo:change-bar-begin change-bar-class="{$class}" xsl:use-attribute-sets="changebar.atts"/>
          </xsl:if>
          <xsl:apply-imports/>
          <!-- close the changebar here if the revisionflag is here and we have set them to be on -->
          <xsl:if test="$use.changebars != 0 ">
            <fo:change-bar-end change-bar-class="{$class}"/>
          </xsl:if>
        </fo:inline>
      </xsl:when>
      <xsl:otherwise>
        <xsl:apply-imports/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  
  <xsl:template match="text()[parent::*[@revisionflag='changed']][count(preceding-sibling::*)=0][count(following-sibling::*)=0] | 
                       biblioref[@revisionflag='changed']">
    <xsl:variable name="class" select="generate-id()"/>
    <fo:inline xsl:use-attribute-sets="nonwrappable.atts">
      <xsl:if test="$use.changebars != 0">
        <fo:change-bar-begin change-bar-class="{$class}" xsl:use-attribute-sets="changebar.atts"/>
      </xsl:if>
      <xsl:apply-imports/>
      <xsl:if test="$use.changebars != 0">
        <fo:change-bar-end change-bar-class="{$class}"/>
      </xsl:if>
    </fo:inline>
  </xsl:template>
  
  <xsl:template match="text()[parent::*[@revisionflag='changed']][count(preceding-sibling::*)=0][count(following-sibling::*)=0]" mode="bibliography.mode">
    <xsl:variable name="class" select="generate-id()"/>
    <fo:inline xsl:use-attribute-sets="nonwrappable.atts">
      <xsl:if test="$use.changebars != 0">
        <fo:change-bar-begin change-bar-class="{$class}" xsl:use-attribute-sets="changebar.atts"/>
      </xsl:if>
      <xsl:apply-imports/>
      <xsl:if test="$use.changebars != 0">
        <fo:change-bar-end change-bar-class="{$class}"/>
      </xsl:if>
    </fo:inline>
  </xsl:template>
  
  <xsl:template match="text()[parent::*[@revisionflag='changed']][count(preceding-sibling::*)=0][count(following-sibling::*)=0]" mode="bibliomixed.mode">
    <xsl:variable name="class" select="generate-id()"/>
    <fo:inline xsl:use-attribute-sets="nonwrappable.atts">
      <xsl:if test="$use.changebars != 0">
        <fo:change-bar-begin change-bar-class="{$class}" xsl:use-attribute-sets="changebar.atts"/>
      </xsl:if>
      <xsl:apply-imports/>
      <xsl:if test="$use.changebars != 0">
        <fo:change-bar-end change-bar-class="{$class}"/>
      </xsl:if>
    </fo:inline>
  </xsl:template>

</xsl:stylesheet>